// user-entrepreneur.ts
import User from "./User";

class UserEntrepreneur extends User {
    private _school?: string;
    private _course?: string;
    private _sneeStatus?: boolean;

    constructor(data: Partial<UserEntrepreneur> = {}) {
        super(data);
        this._school = data.school;
        this._course = data.course;
        this._sneeStatus = data.sneeStatus;
    }

    get school(): string | undefined {
        return this._school;
    }

    set school(value: string | undefined) {
        this._school = value;
    }

    get course(): string | undefined {
        return this._course;
    }

    set course(value: string | undefined) {
        this._course = value;
    }

    get sneeStatus(): boolean | undefined {
        return this._sneeStatus;
    }

    set sneeStatus(value: boolean | undefined) {
        this._sneeStatus = value;
    }

    toObject() {
        return {
            ...super.toObject(),
            school: this._school,
            course: this._course,
            sneeStatus: this._sneeStatus,
        };
    }
}

export default UserEntrepreneur;
